

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.3.22. dump &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.3.23. index_column_diff" href="index_column_diff.html" />
    <link rel="prev" title="7.3.21. delete" href="delete.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/commands/dump.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="index_column_diff.html" title="7.3.23. index_column_diff"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="delete.html" title="7.3.21. delete"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" accesskey="U"><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.22. </span><code class="docutils literal notranslate"><span class="pre">dump</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="dump">
<h1><span class="section-number">7.3.22. </span><code class="docutils literal notranslate"><span class="pre">dump</span></code><a class="headerlink" href="#dump" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.3.22.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p>dump - Output a schema and data of a database.</p>
<p>We explain about dump that one of built-in command of Groonga.
Built-in commands of Groonga execute by sending a request to groonga server via argument of groonga execution file, standard input, and socket.</p>
<p>The dump command outputs schemas and data of a database as a format that can read from after.</p>
<p>The dump command mainly uses from a command line. Because a dump result is big.
The dump command mainly uses for the backup of databases.</p>
<p>Groonga can directly understand the format of the dump command. Therefore, we can copy databases as below.</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>% groonga original/db dump &gt; dump.grn
% mkdir backup
% groonga -n backup/db &lt; dump.grn
</pre></div>
</div>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.3.22.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>dump [tables=null]
     [dump_plugins=yes]
     [dump_schema=yes]
     [dump_records=yes]
     [dump_indexes=yes]
     [dump_configs=yes]
     [sort_hash_table=no]
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.3.22.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here is the sample schema and data to check dump behaviour:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>plugin_register token_filters/stop_word
table_create Bookmarks TABLE_HASH_KEY ShortText
column_create Bookmarks title COLUMN_SCALAR ShortText
table_create Lexicon TABLE_PAT_KEY ShortText
table_create Sites TABLE_NO_KEY
column_create Sites url COLUMN_SCALAR ShortText
column_create Lexicon bookmark_title COLUMN_INDEX Bookmarks title
load --table Bookmarks
[
{&quot;_key&quot;:&quot;Groonga&quot;, &quot;title&quot;:&quot;Introduction to Groonga&quot;},
{&quot;_key&quot;:&quot;PGroonga&quot;, &quot;title&quot;:&quot;Introduction to PGroonga&quot;},
{&quot;_key&quot;:&quot;Mroonga&quot;, &quot;title&quot;:&quot;Introduction to Mroonga&quot;}
]
load --table Sites
[
{&quot;_id&quot;: 1, &quot;url&quot;:&quot;http://groonga.org&quot;},
{&quot;_id&quot;: 2, &quot;url&quot;:&quot;http://mroonga.org&quot;}
]
</pre></div>
</div>
<p>Dump all data in database:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>&gt; dump
plugin_register token_filters/stop_word

table_create Sites TABLE_NO_KEY
column_create Sites url COLUMN_SCALAR ShortText

table_create Bookmarks TABLE_HASH_KEY ShortText
column_create Bookmarks title COLUMN_SCALAR ShortText

table_create Lexicon TABLE_PAT_KEY ShortText

load --table Sites
[
[&quot;_id&quot;,&quot;url&quot;],
[1,&quot;http://groonga.org&quot;],
[2,&quot;http://mroonga.org&quot;]
]

load --table Bookmarks
[
[&quot;_key&quot;,&quot;title&quot;],
[&quot;Groonga&quot;,&quot;Introduction to Groonga&quot;],
[&quot;PGroonga&quot;,&quot;Introduction to PGroonga&quot;],
[&quot;Mroonga&quot;,&quot;Introduction to Mroonga&quot;]
]

create Lexicon bookmark_title COLUMN_INDEX Bookmarks title
</pre></div>
</div>
<p>Dump schema and specific table data:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>&gt; dump Bookmarks
plugin_register token_filters/stop_word

table_create Sites TABLE_NO_KEY
column_create Sites url COLUMN_SCALAR ShortText

table_create Bookmarks TABLE_HASH_KEY ShortText
column_create Bookmarks title COLUMN_SCALAR ShortText

table_create Lexicon TABLE_PAT_KEY ShortText

load --table Bookmarks
[
[&quot;_key&quot;,&quot;title&quot;],
[&quot;Groonga&quot;,&quot;Introduction to Groonga&quot;],
[&quot;PGroonga&quot;,&quot;Introduction to PGroonga&quot;],
[&quot;Mroonga&quot;,&quot;Introduction to Mroonga&quot;]
]

column_create Lexicon bookmark_title COLUMN_INDEX Bookmarks title
</pre></div>
</div>
<p>Dump plugin only:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>&gt; dump --dump_schema no --dump_records no --dump_indexes no
plugin_register token_filters/stop_word
</pre></div>
</div>
<p>Dump records only:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>&gt; dump --dump_schema no --dump_plugins no --dump_indexes no
load --table Sites
[
[&quot;_id&quot;,&quot;url&quot;],
[1,&quot;http://groonga.org&quot;],
[2,&quot;http://mroonga.org&quot;]
]

load --table Bookmarks
[
[&quot;_key&quot;,&quot;title&quot;],
[&quot;Groonga&quot;,&quot;Introduction to Groonga&quot;],
[&quot;PGroonga&quot;,&quot;Introduction to PGroonga&quot;],
[&quot;Mroonga&quot;,&quot;Introduction to Mroonga&quot;]
]
</pre></div>
</div>
<p>Dump schema only:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>&gt; dump --dump_records no --dump_plugins no --dump_indexes no
table_create Sites TABLE_NO_KEY
column_create Sites url COLUMN_SCALAR ShortText

table_create Bookmarks TABLE_HASH_KEY ShortText
column_create Bookmarks title COLUMN_SCALAR ShortText

table_create Lexicon TABLE_PAT_KEY ShortText
</pre></div>
</div>
<p>Dump sorted hash table data:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>&gt; dump Bookmarks --sort_hash_table yes
plugin_register token_filters/stop_word

table_create Sites TABLE_NO_KEY
column_create Sites url COLUMN_SCALAR ShortText

table_create Bookmarks TABLE_HASH_KEY ShortText
column_create Bookmarks title COLUMN_SCALAR ShortText

table_create Lexicon TABLE_PAT_KEY ShortText

load --table Bookmarks
[
[&quot;_key&quot;,&quot;title&quot;],
[&quot;Groonga&quot;,&quot;Introduction to Groonga&quot;],
[&quot;Mroonga&quot;,&quot;Introduction to Mroonga&quot;],
[&quot;PGroonga&quot;,&quot;Introduction to PGroonga&quot;]
]

column_create Lexicon bookmark_title COLUMN_INDEX Bookmarks title
</pre></div>
</div>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.3.22.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>There are optional parameters.</p>
<div class="section" id="optional-parameters">
<h3><span class="section-number">7.3.22.4.1. </span>Optional parameters<a class="headerlink" href="#optional-parameters" title="Permalink to this headline">¶</a></h3>
<div class="section" id="tables">
<h4><span class="section-number">7.3.22.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">tables</span></code><a class="headerlink" href="#tables" title="Permalink to this headline">¶</a></h4>
<p>出力対象のテーブルを「,」（カンマ）区切りで指定します。存在しないテーブルを指定した場合は無視されます。</p>
</div>
<div class="section" id="dump-plugins">
<h4><span class="section-number">7.3.22.4.1.2. </span><code class="docutils literal notranslate"><span class="pre">dump_plugins</span></code><a class="headerlink" href="#dump-plugins" title="Permalink to this headline">¶</a></h4>
<div class="versionadded">
<p><span class="versionmodified added">New in version 5.0.3.</span></p>
</div>
<p>You can customize the output whether it contains registered plugins or not.
To exclude registered plugins from the output, specify <code class="docutils literal notranslate"><span class="pre">no</span></code>.</p>
<p>The default value is <code class="docutils literal notranslate"><span class="pre">yes</span></code>.</p>
</div>
<div class="section" id="dump-schema">
<h4><span class="section-number">7.3.22.4.1.3. </span><code class="docutils literal notranslate"><span class="pre">dump_schema</span></code><a class="headerlink" href="#dump-schema" title="Permalink to this headline">¶</a></h4>
<div class="versionadded">
<p><span class="versionmodified added">New in version 5.0.3.</span></p>
</div>
<p>You can customize the output whether it contains database schema or not.
To exclude database schema from the output, specify <code class="docutils literal notranslate"><span class="pre">no</span></code>.</p>
<p>The default value is <code class="docutils literal notranslate"><span class="pre">yes</span></code>.</p>
</div>
<div class="section" id="dump-records">
<h4><span class="section-number">7.3.22.4.1.4. </span><code class="docutils literal notranslate"><span class="pre">dump_records</span></code><a class="headerlink" href="#dump-records" title="Permalink to this headline">¶</a></h4>
<div class="versionadded">
<p><span class="versionmodified added">New in version 5.0.3.</span></p>
</div>
<p>You can customize the output whether it contains records or not.
To exclude records from the output, specify <code class="docutils literal notranslate"><span class="pre">no</span></code>.</p>
<p>The default value is <code class="docutils literal notranslate"><span class="pre">yes</span></code>.</p>
</div>
<div class="section" id="dump-indexes">
<h4><span class="section-number">7.3.22.4.1.5. </span><code class="docutils literal notranslate"><span class="pre">dump_indexes</span></code><a class="headerlink" href="#dump-indexes" title="Permalink to this headline">¶</a></h4>
<div class="versionadded">
<p><span class="versionmodified added">New in version 5.0.3.</span></p>
</div>
<p>You can customize the output whether it contains indexes or not.
To exclude indexes from the output, specify <code class="docutils literal notranslate"><span class="pre">no</span></code>.</p>
<p>The default value is <code class="docutils literal notranslate"><span class="pre">yes</span></code>.</p>
</div>
<div class="section" id="sort-hash-table">
<h4><span class="section-number">7.3.22.4.1.6. </span><code class="docutils literal notranslate"><span class="pre">sort_hash_table</span></code><a class="headerlink" href="#sort-hash-table" title="Permalink to this headline">¶</a></h4>
<div class="versionadded">
<p><span class="versionmodified added">New in version 7.0.5.</span></p>
</div>
<p>You can ascending sort by <code class="docutils literal notranslate"><span class="pre">_key</span></code> the output of hash table when it contains hash table.
To sort the output of hash table, specify <code class="docutils literal notranslate"><span class="pre">yes</span></code>.</p>
<p>The default value is <code class="docutils literal notranslate"><span class="pre">no</span></code>.</p>
</div>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.3.22.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p>データベースのスキーマとデータをGroongaの組み込みコマンド呼び出し形式で出力します。output_type指定は無視されます。</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.3.22. <code class="docutils literal notranslate"><span class="pre">dump</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.3.22.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.3.22.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.3.22.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.3.22.4. Parameters</a><ul>
<li><a class="reference internal" href="#optional-parameters">7.3.22.4.1. Optional parameters</a><ul>
<li><a class="reference internal" href="#tables">7.3.22.4.1.1. <code class="docutils literal notranslate"><span class="pre">tables</span></code></a></li>
<li><a class="reference internal" href="#dump-plugins">7.3.22.4.1.2. <code class="docutils literal notranslate"><span class="pre">dump_plugins</span></code></a></li>
<li><a class="reference internal" href="#dump-schema">7.3.22.4.1.3. <code class="docutils literal notranslate"><span class="pre">dump_schema</span></code></a></li>
<li><a class="reference internal" href="#dump-records">7.3.22.4.1.4. <code class="docutils literal notranslate"><span class="pre">dump_records</span></code></a></li>
<li><a class="reference internal" href="#dump-indexes">7.3.22.4.1.5. <code class="docutils literal notranslate"><span class="pre">dump_indexes</span></code></a></li>
<li><a class="reference internal" href="#sort-hash-table">7.3.22.4.1.6. <code class="docutils literal notranslate"><span class="pre">sort_hash_table</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.3.22.5. Return value</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="delete.html"
                        title="previous chapter"><span class="section-number">7.3.21. </span><code class="docutils literal notranslate"><span class="pre">delete</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="index_column_diff.html"
                        title="next chapter"><span class="section-number">7.3.23. </span><code class="docutils literal notranslate"><span class="pre">index_column_diff</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="index_column_diff.html" title="7.3.23. index_column_diff"
             >next</a> |</li>
        <li class="right" >
          <a href="delete.html" title="7.3.21. delete"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" ><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.22. </span><code class="docutils literal notranslate"><span class="pre">dump</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>